
//interrupt
#define ISR_FREQ 170     //740Hz        // Sets the speed of the ISR - LOWER IS FASTER 


void protocolRun()
{
  sei(); 
  if (Serial.available()>=3)
  {
    int val;

    val = Serial.read();      // read the serial port
    if (val=='1') //set Led
    {    
      setLed(Serial.read()-48,Serial.read()-48);
    }
    else if (val=='0') //clear Led
    {    
      clearLed(Serial.read()-48,Serial.read()-48);
    }
    else if (val=='2') //toggleLed
    {    
      toggleLed(Serial.read()-48,Serial.read()-48);
    }

    else if (val=='3') //ligth column
    {    
      //toggleLed(Serial.read()-48,Serial.read()-48);
    }

    else if (val=='43') //dark column
    {    
    //  toggleLed(Serial.read()-48,Serial.read()-48);
    }
    else if (val=='5') //toggle column
    {   
     //toggle leds in column  
     int column= Serial.read()-48;
     Serial.read()-48;
       for(int i=0;i<8;i++)
        toggleLed(i,column);
    }


    else if(val=='6')
    {
      int a=Serial.read();int b=Serial.read();
      if (a=='0')
         clearAllLights();
      if (a=='1')
         lightAllLed();
         
    }
  } 
}


ISR(TIMER2_COMPA_vect) {  //Called when ISR triggers
  // protocolRun();
  updateLED();

}  

void setISRtimer(){  // setup ISR timer 
  TCCR2A = (1<<WGM21);                  // WGM22=0 + WGM21=1 + WGM20=0 = Mode2 (CTC)
  TCCR2B = (1<<CS22)|(0<<CS21)|(1<<CS20);  // set prescaler to /128(125kHz)
  TCNT2 = 0;                                      //clear counter
  OCR2A = ISR_FREQ;                        // set TOP (divisor) - see #define
}

void startISR(){  // Starts the ISR
  TIMSK2=(1<<OCIE2A);                     // set interrupts=enabled (calls ISR(TIMER2_COMPA_vect)
}

void stopISR(){    // Stops the ISR
  TIMSK2=(0<<OCIE2A);                    // disable interrupts
} 


